#
#void bpp8_scroll_1024_up(int x,int y,int w,int h,int line)
#{
#  char * bmp;
#  int H;
#  int upline   = y * 1024 + x;
#  int downline = (y+line) * 1024 + x;
#  int page = 0;
#  
#  bmp = (char*)malloc(w*sizeof(char));
#  H = h - line;
#  vga_setpage(downline>>16);
#  while (H>0) {
#    if (page) vga_setpage(downline>>16);
#    memcpy(bmp,(graph_mem+(downline&0xffff)),w);
#    if (page) vga_setpage(upline>>16);
#    memcpy((graph_mem+(upline&0xffff)),bmp,w);
#    upline += 1024; downline += 1024; H--;
#    page = ((upline&0xff0000)!=(downline&0xff0000));
#    if (!page) { if ((upline&0xffff)<1024) page++;  }
#  }
#  free(bmp);
#
#}
#
	.file	"bpp8_scroll_1024.c"
	.version	"01.01"
gcc2_compiled.:
.text
	.align 4
.globl bpp8_scroll_1024_up
	.type	 bpp8_scroll_1024_up,@function
bpp8_scroll_1024_up:
	pushl %ebp
	movl %esp,%ebp
	subl $20,%esp
# upline = y * 1024 + x
	movl 12(%ebp),%eax
	sall $10,%eax
	addl 8(%ebp),%eax
	movl %eax,-12(%ebp)
# downline = (y+line) * 1024 + x
	movl 12(%ebp),%eax
	addl 24(%ebp),%eax
	sall $10,%eax
	addl 8(%ebp),%eax
	movl %eax,-16(%ebp)
# page = 0
	movl $0,-20(%ebp)
# bmp = malloc(w);
	movl 16(%ebp),%eax
	pushl %eax
	call malloc
	addl $4,%esp
	movl %eax,-4(%ebp)
# H = h - line
	movl 20(%ebp),%eax
	subl 24(%ebp),%eax
	movl %eax,-8(%ebp)
# vga_setpage(downline>>16);
	movl -16(%ebp),%eax
	sarl $16,%eax
	pushl %eax
	call vga_setpage
	addl $4,%esp
.L2:
# while (H>0) {
	cmpl $0,-8(%ebp)
	jg .L4
	jmp .L3
	.align 4
.L4:
# if (page) vga_setpage(downline>>16);
	cmpl $0,-20(%ebp)
	je .L5
	movl -16(%ebp),%eax
	sarl $16,%eax
	pushl %eax
	call vga_setpage
	addl $4,%esp
.L5:
# memcpy(bmp,graph_mem+(downline&0xffff),w); 

	movl 16(%ebp),%eax
	pushl %eax
	movzwl -16(%ebp),%eax
	movl %eax,%edx
	addl graph_mem,%edx
	pushl %edx
	movl -4(%ebp),%eax
	pushl %eax
	call memcpy
	addl $12,%esp

# if (page) vga_setpage(upline>>16);
	cmpl $0,-20(%ebp)
	je .L6
	movl -12(%ebp),%eax
	sarl $16,%eax
	pushl %eax
	call vga_setpage
	addl $4,%esp
.L6:
# memcpy(graph_mem+(upline&0xffff),bmp,w);
	movl 16(%ebp),%eax
	pushl %eax
	movl -4(%ebp),%eax
	pushl %eax
	movzwl -12(%ebp),%eax
	movl %eax,%edx
	addl graph_mem,%edx
	pushl %edx
	call memcpy
	addl $12,%esp
# upline += 1024, downline += 1024, H--
	addl $1024,-12(%ebp)
	addl $1024,-16(%ebp)
	decl -8(%ebp)
# page = (upline&0xff0000)!=(downline&0xff0000)
# if (!page) { if ((upline&0xffff)<1024) page=1; }
	movl -12(%ebp),%eax
	andl $16711680,%eax
	movl -16(%ebp),%edx
	andl $16711680,%edx
	cmpl %edx,%eax
	setne %al
	movzbl %al,%ecx
	movl %ecx,-20(%ebp)
	cmpl $0,-20(%ebp)
	jne .L7
	movzwl -12(%ebp),%eax
	cmpl $1023,%eax
	jg .L8
	incl -20(%ebp)
.L8:
.L7:
	jmp .L2
	.align 4
.L3:
	movl -4(%ebp),%eax
	pushl %eax
	call free
	addl $4,%esp
.L1:
	leave
	ret
.Lfe1:
	.size	 bpp8_scroll_1024_up,.Lfe1-bpp8_scroll_1024_up
	.align 4

#
#void bpp8_scroll_1024_down(int x,int y,int w,int h,int line)
#{
#  char * bmp;
#  int H;
#  int downline = (y+h-1)*1024 + x;
#  int upline = downline - line * 1024;
#  int page = 0;
#  
#  bmp = (char*)malloc(w*sizeof(char));
#  H = h - line;
#
#  vga_setpage(upline>>16);
#  while (H>0) {
#    if (page) vga_setpage(upline>>16);
#    memcpy(bmp,(graph_mem+(upline&0xffff)),w);
#    if (page) vga_setpage(downline>>16);
#    memcpy((graph_mem+(downline&0xffff)),bmp,w);
#    upline -= 1024; downline -= 1024; H--;
#    page = ((upline&0xff0000)!=(downline&0xff0000));
#    if (!page) { if ((0x10000-(downline&0xffff))<1024) page=1;  }
#  }
#  
#  free(bmp);
#}
#

.globl bpp8_scroll_1024_down
	.type	 bpp8_scroll_1024_down,@function
bpp8_scroll_1024_down:
	pushl %ebp
	movl %esp,%ebp
	subl $20,%esp
	movl 12(%ebp),%eax
	addl 20(%ebp),%eax
	leal -1(%eax),%edx
	movl %edx,%eax
	movl %eax,%edx
	sall $10,%edx
	movl 8(%ebp),%ecx
	addl %edx,%ecx
	movl %ecx,-12(%ebp)
	movl 24(%ebp),%eax
	movl %eax,%edx
	movl %edx,%eax
	sall $10,%eax
	movl -12(%ebp),%ecx
	subl %eax,%ecx
	movl %ecx,-16(%ebp)
	movl $0,-20(%ebp)
	movl 16(%ebp),%eax
	pushl %eax
	call malloc
	addl $4,%esp
	movl %eax,-4(%ebp)
	movl 20(%ebp),%ecx
	subl 24(%ebp),%ecx
	movl %ecx,-8(%ebp)
	movl -16(%ebp),%eax
	sarl $16,%eax
	pushl %eax
	call vga_setpage
	addl $4,%esp
.L10:
	cmpl $0,-8(%ebp)
	jg .L12
	jmp .L11
	.align 4
.L12:
	cmpl $0,-20(%ebp)
	je .L13
	movl -16(%ebp),%eax
	sarl $16,%eax
	pushl %eax
	call vga_setpage
	addl $4,%esp
.L13:
	movl 16(%ebp),%eax
	pushl %eax
	movzwl -16(%ebp),%eax
	movl %eax,%edx
	addl graph_mem,%edx
	pushl %edx
	movl -4(%ebp),%eax
	pushl %eax
	call memcpy
	addl $12,%esp
	cmpl $0,-20(%ebp)
	je .L14
	movl -12(%ebp),%eax
	sarl $16,%eax
	pushl %eax
	call vga_setpage
	addl $4,%esp
.L14:
	movl 16(%ebp),%eax
	pushl %eax
	movl -4(%ebp),%eax
	pushl %eax
	movzwl -12(%ebp),%eax
	movl %eax,%edx
	addl graph_mem,%edx
	pushl %edx
	call memcpy
	addl $12,%esp
	addl $-1024,-16(%ebp)
	addl $-1024,-12(%ebp)
	decl -8(%ebp)
	movl -16(%ebp),%eax
	andl $16711680,%eax
	movl -12(%ebp),%edx
	andl $16711680,%edx
	cmpl %edx,%eax
	setne %al
	movzbl %al,%ecx
	movl %ecx,-20(%ebp)
	cmpl $0,-20(%ebp)
	jne .L15
	movzwl -12(%ebp),%eax
	movl $65536,%edx
	subl %eax,%edx
	cmpl $1023,%edx
	jg .L16
	movl $1,-20(%ebp)
.L16:
.L15:
	jmp .L10
	.align 4
.L11:
	movl -4(%ebp),%eax
	pushl %eax
	call free
	addl $4,%esp
.L9:
	leave
	ret
.Lfe2:
	.size	 bpp8_scroll_1024_down,.Lfe2-bpp8_scroll_1024_down
	.align 4

#
#int bpp8_scroll_1024(int x,int y,int w,int h,int line)
#{
#  if (line>0) bpp8_scroll_1024_up(x,y,w,h,line); else
#  if (line<0) bpp8_scroll_1024_down(x,y,w,h,-line);
#  return line;
#}
#

.globl bpp8_scroll_1024
	.type	 bpp8_scroll_1024,@function
bpp8_scroll_1024:
	pushl %ebp
	movl %esp,%ebp
	cmpl $0,24(%ebp)
	jle .L18
	movl 24(%ebp),%eax
	pushl %eax
	movl 20(%ebp),%eax
	pushl %eax
	movl 16(%ebp),%eax
	pushl %eax
	movl 12(%ebp),%eax
	pushl %eax
	movl 8(%ebp),%eax
	pushl %eax
	call bpp8_scroll_1024_up
	addl $20,%esp
	jmp .L19
	.align 4
.L18:
	cmpl $0,24(%ebp)
	jge .L20
	movl 24(%ebp),%eax
	negl %eax
	pushl %eax
	movl 20(%ebp),%eax
	pushl %eax
	movl 16(%ebp),%eax
	pushl %eax
	movl 12(%ebp),%eax
	pushl %eax
	movl 8(%ebp),%eax
	pushl %eax
	call bpp8_scroll_1024_down
	addl $20,%esp
.L20:
.L19:
	movl 24(%ebp),%eax
	jmp .L17
	.align 4
.L17:
	leave
	ret
.Lfe3:
	.size	 bpp8_scroll_1024,.Lfe3-bpp8_scroll_1024
	.ident	"GCC: (GNU) 2.7.2.3"
